"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var _default = function _default(context) {
  var option = context.options[0] || 'never';
  var sourceCode = context.getSourceCode();
  var reporter = function reporter(node, message, fix) {
    return function () {
      context.report({
        fix: fix,
        message: message,
        node: node
      });
    };
  };
  var makeReporters = function makeReporters(node, tokenToFix) {
    return {
      dangle: reporter(node, 'Unexpected trailing delimiter', function (fixer) {
        return fixer.replaceText(tokenToFix, '');
      }),
      noDangle: reporter(node, 'Missing trailing delimiter', function (fixer) {
        return fixer.insertTextAfter(tokenToFix, ',');
      })
    };
  };
  var evaluate = function evaluate(node, lastChildNode) {
    if (!lastChildNode) {
      return;
    }
    var _sourceCode$getLastTo = sourceCode.getLastTokens(node, 2),
      _sourceCode$getLastTo2 = _slicedToArray(_sourceCode$getLastTo, 2),
      penultimateToken = _sourceCode$getLastTo2[0],
      lastToken = _sourceCode$getLastTo2[1];
    var isDangling = [';', ','].indexOf(penultimateToken.value) > -1;
    var isMultiLine = penultimateToken.loc.start.line !== lastToken.loc.start.line;
    var report = makeReporters(lastChildNode, penultimateToken);
    if (option === 'always' && !isDangling) {
      report.noDangle();
      return;
    }
    if (option === 'never' && isDangling) {
      report.dangle();
      return;
    }
    if (option === 'always-multiline' && !isDangling && isMultiLine) {
      report.noDangle();
      return;
    }
    if (option === 'always-multiline' && isDangling && !isMultiLine) {
      report.dangle();
      return;
    }
    if (option === 'only-multiline' && isDangling && !isMultiLine) {
      report.dangle();
      return;
    }
  };

  // required for reporting the correct position
  var getLast = function getLast(property, indexer) {
    if (!property) {
      return indexer;
    }
    if (!indexer) {
      return property;
    }
    if (property.loc.end.line > indexer.loc.end.line) {
      return property;
    }
    if (indexer.loc.end.line > property.loc.end.line) {
      return indexer;
    }
    if (property.loc.end.column > indexer.loc.end.column) {
      return property;
    }
    return indexer;
  };
  return {
    ObjectTypeAnnotation: function ObjectTypeAnnotation(node) {
      evaluate(node, getLast(_lodash["default"].last(node.properties), _lodash["default"].last(node.indexers)));
    },
    TupleTypeAnnotation: function TupleTypeAnnotation(node) {
      evaluate(node, _lodash["default"].last(node.types));
    }
  };
};
exports["default"] = _default;